# start the mongod server in a separate prosess
Add-Content -Value "Starting" -Path C:\test.log

$mongod_args = "--port 27017 --dbpath $env:mongo_data --logpath $env:TEMP\mongoDatabase.log"
Start-Process (Join-Path $env:mongo_home "bin\mongod.exe") $mongod_args

# get endpoint of a mongos instance
& (Join-Path $env:java_home "\bin\java.exe") -jar .\DiscoverEndpoints.jar "Router" 1 "router" (Join-Path $env:endpoints_path "routerEndpoint.txt")
$routerEndpoint = Get-Content (Join-Path $env:endpoints_path "routerEndpoint.txt")

$routerEndpoint = $routerEndpoint -split ":"
Add-Content -Value "endpoints $routerEndpoint" -Path C:\test.log

$routerIP = $routerEndpoint[0]
$routerPort = $routerEndpoint[1]
Add-Content -Value "ip $routerIP port $routerPort" -Path C:\test.log

# wait until that mongos instance is up and running
Add-Content -Value "Waiting fore mongos" -Path C:\test.log
& .\waitForeMongoConnection.ps1 -addr $routerEndpoint[0] -port ($routerEndpoint[1] -as [int])

# add this mongod server to the mongos shard
Add-Content -Value "mongos up, adding shard" -Path C:\test.log


& shardDB.ps1