package evenosmaster.util;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.net.InetSocketAddress;
import java.util.Iterator;
import java.util.Map;

import com.microsoft.windowsazure.serviceruntime.Role;
import com.microsoft.windowsazure.serviceruntime.RoleEnvironment;
import com.microsoft.windowsazure.serviceruntime.RoleInstance;
import com.microsoft.windowsazure.serviceruntime.RoleInstanceEndpoint;


public class DiscoverEndpoints {
	
	
	public DiscoverEndpoints(String roleName, int numInstances, String endpointNames, String outputDir) throws FileNotFoundException {
		PrintWriter pw = new PrintWriter(outputDir);
		
		if(endpointNames.charAt(0) == '"')
			endpointNames = endpointNames.substring(1, endpointNames.length()-2);
		
		Map<String, Role> roles = RoleEnvironment.getRoles();
		Map<String, RoleInstance> configRoleInstances = roles.get(roleName).getInstances();
		
		Iterator<RoleInstance> instances = configRoleInstances.values().iterator();
		RoleInstance firstConfigInstance = null;
		for(int i = 0; i < Math.min(numInstances, configRoleInstances.size()); i++){
			firstConfigInstance = instances.next();
			Map<String, RoleInstanceEndpoint> firstConfigRoleInsanceEndpoints = 
					firstConfigInstance.getInstanceEndpoints();
			if(endpointNames.equalsIgnoreCase("any")){
				boolean isFirst = true;
				for(String endpoint : firstConfigRoleInsanceEndpoints.keySet()){
					if(!isFirst) pw.print(',');
					isFirst = false;
					InetSocketAddress addr = firstConfigRoleInsanceEndpoints.get(endpoint).getIpEndPoint();
					pw.print(addr.getAddress().getHostAddress()+":"+addr.getPort());
				}
			}else{
				boolean isFirst = true;
				for(String endpoint : endpointNames.split(",")){
					if(firstConfigRoleInsanceEndpoints.containsKey(endpoint)){
						if(!isFirst) pw.print(',');
						isFirst = false;
						InetSocketAddress addr = firstConfigRoleInsanceEndpoints.get(endpoint).getIpEndPoint();
						pw.print(addr.getAddress().getHostAddress()+":"+addr.getPort());
					}
				}
			}
			pw.println();
		}
		
		pw.close();
	}

	
	public static void main(String[] args) {
		try {
			new DiscoverEndpoints(args[0], Integer.parseInt(args[1]), args[2], args[3]);
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}		
	}
}
