package evenosmaster.util;

import java.io.Closeable;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.TimerTask;

public class StatCollectorTask extends TimerTask implements Closeable {
	private int previousCount = 0;
	private int previousSize = 0;
	private PrintWriter pw;
	private MongoLoade ls;

	public StatCollectorTask(MongoLoade ls, File statisticsFile) throws IOException {
		super();
		this.ls = ls;
		pw = new PrintWriter(new FileWriter(statisticsFile));
		pw.println("DeltaCount, DeltaSize\n");
		pw.flush();
	}

	@Override
	public void run() {
		Statistics stats = ls.getStats();

		int dCount = stats.getCount() - previousCount;
		int dSize = stats.getSize() - previousSize;

		this.previousCount = stats.getCount();
		this.previousSize = stats.getSize();

		pw.println(dCount + ", " + dSize + "\n");
		pw.flush();

	}

	public void close() throws IOException {
		pw.flush();
		pw.close();
	}

}