package evenosmaster.util;

import java.util.concurrent.atomic.AtomicInteger;

public class StatisticsCollector {
	private final AtomicInteger documentCount;
	private final AtomicInteger acumolatedDocumentSize;

	public StatisticsCollector() {
		this.documentCount = new AtomicInteger();
		this.acumolatedDocumentSize = new AtomicInteger();
	}

	public int incrementDocumentCount() {
		return documentCount.incrementAndGet();
	}

	public int getDocumentCount() {
		return documentCount.get();
	}

	public int increaseAccumolatedDocumentSize(int size) {
		return acumolatedDocumentSize.getAndAdd(size);
	}

	public int getAccumolatedSize() {
		return acumolatedDocumentSize.get();
	}
	
	//Return a immutable copy of the current state
	public Statistics getCurrentStatistics(){
		return new Statistics(acumolatedDocumentSize.get(), documentCount.get());
	}
	
	@Override
	public String toString() {
		return "Doc count: " + documentCount.get() + ", AcumolatedSize: " + acumolatedDocumentSize.get();
	}
}
