package evenosmaster.util.xmltojson;

import java.io.Closeable;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.Flushable;
import java.io.IOException;
import java.io.PrintWriter;

public class FileWritingObjectHandler implements ObjectHandler<String>, Closeable, Flushable{
	
	private String outputFolder;
	private PrintWriter pw;
//	private boolean notFirst = false;
	long revisionCounter;
	int pageCounter;
	String collection;
	
	public FileWritingObjectHandler(String target) throws FileNotFoundException {
		this.outputFolder = target;
	}
	
	

	public void handleObject(String object) {
		pw.write(object);
		pw.println();
		pw.flush();
		revisionCounter++;
	}

	public void close() throws IOException {
		pw.close();
	}

	public void flush() throws IOException {
		pw.flush();		
	}



	public void collection(String collection) throws IOException {
		if(this.collection != null){
			flush();
			close();
			System.out.println(this.collection + ": " + (revisionCounter));
		}
		revisionCounter = 0;
		
		this.collection = collection;
		pw = new PrintWriter(outputFolder + File.separator + "a-"+ String.format("%04d", pageCounter++) + ".json");
		pw.println(collection);
	}

}
