package evenosmaster.util.xmltojson;

import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.Scanner;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.xml.sax.SAXException;

public class Main {

	public Main(InputStream source, String targetFolder) throws SAXException, IOException, ParserConfigurationException {
		SAXParserFactory factory = SAXParserFactory.newInstance();
		SAXParser saxParser = factory.newSAXParser();
		
		FileWritingObjectHandler poh = new FileWritingObjectHandler(targetFolder);
		
		saxParser.parse(source, new EvenosmasterHandeler(poh));
		System.out.println(poh.collection + ": " + (poh.revisionCounter));

		poh.flush();
		poh.close();
	}
	
	public static void main(String[] args) {

			try {
				new Main(new FileInputStream(args[0]), args[1]);
			} catch (SAXException e) {
				e.printStackTrace();
			} catch (IOException e) {
				e.printStackTrace();
			} catch (ParserConfigurationException e) {
				e.printStackTrace();
			}

			
			//Hold exit
			new Scanner(System.in).nextLine();
	}
	
}
